#! /usr/bin/env python
# -*- python -*-
# Generated by PAGE version 4.0
# In conjunction with Tcl version 8.6
#    Feb. 12, 2013 07:10:39 PM
import sys

py2 = py30 = py31 = False
version = sys.hexversion
if version >= 0x020600F0 and version < 0x03000000 :
    py2 = True    # Python 2.6 or 2.7
    from Tkinter import *
    import ttk
elif version >= 0x03000000 and version < 0x03010000 :
    py30 = True
    from tkinter import *
    import ttk
elif version >= 0x03010000:
    py31 = True
    from tkinter import *
    import tkinter.ttk as ttk
else:
    print ("""
    You do not have a version of python supporting ttk widgets..
    You need a version >= 2.6 to execute PAGE modules.
    """)
    sys.exit()



def vp_start_gui():
    '''Starting point when module is the main routine.'''
    global val, w, root
    root = Tk()
    root.title('Vrex_for_Python')
    root.geometry('600x573+217+132')
    w = Vrex_for_Python (root)
    init()
    root.mainloop()

w = None
def create_Vrex_for_Python (root):
    '''Starting point when module is imported by another program.'''
    global w, w_win
    if w: # So we have only one instance of window.
        return
    w = Toplevel (root)
    w.title('Vrex_for_Python')
    w.geometry('600x573+217+132')
    w_win = Vrex_for_Python (w)
    init()
    return w_win

def destroy_Vrex_for_Python ():
    global w
    w.destroy()
    w = None




def init():
    pass


import vrex_help
import tkFileDialog

def clear_textbox(o):
    o.delete(1.0, END)


def display(level):
    go()
    clear_textbox(o_m)
    for i in range(len(mo)-1):
        if mo[i] == None:
            insert_text(o_m, "Match failed\n")
        else:
            if level <= len(mo[i].groups()):
                # Insert the text corresponding to the match group.
                start, end = mo[i].span(level)
                str = s_lines[i][start:end]
                insert_text(o_m, str+'\n')
                line = '%d.0' % (i+1,)
                last = '%d.%d' % (i+1,end)
                o_m.tag_add(levels[level], line, last) # Colorize text.



def do_match():
    import re
    global mo, rexp, sample, s_lines
    rexp = read_textbox(o_e)
    rexp = rexp.strip()
    sample = read_textbox(o_s)
    s_lines = sample.split('\n')
    rc = re.compile(rexp)
    mo = []
    for line in s_lines:
        mo.append(rc.search(line))

def go():
    regexp_colorize()
    do_match()
    sample_colorize()

def help():
    vrex_help.create_Vrex_Help(root)

def init():
    # This is executed after the GUI is drawn.
    global colors, color_noreport, color_lookahead, levels, o_e, o_s, o_m
    # Define the object names for the three text windows;
    o_e = w.Expression
    o_s = w.Sample
    o_m = w.Matches
    # the colors for the different matching groups
    colors = ['red', 'blue', 'darkgreen', 'magenta', 'sienna', 'purple',
              'firebrick', 'deeppink', 'deeppink', 'deepskyblue1']
    # background color to visualize the non-reporting group (?:...)
    color_noreport = 'cyan'
    # background color to visualize the lookhead group (?=...) and (?!...)
    color_lookahead = 'plum'
    # define levels
    levels = ['e0', 'e1', 'e2', 'e3', 'e4', 'e5', 'e6', 'e7', 'e8', 'e9']
    # configure the tags to be used.
    for i in range(len(levels)):
        o_e.tag_configure(levels[i], foreground=colors[i])
        o_s.tag_configure(levels[i], foreground=colors[i])
        o_m.tag_configure(levels[i], foreground=colors[i])
    o_e.tag_configure('lookahead', background=color_lookahead)
    o_e.tag_configure('noreport', background=color_noreport)


def insert_text(o, str):
    o.insert(END, str)

def load_regular_expression():
    regex_file = tkFileDialog.askopenfilename(filetypes=[("all files", "*")])
    if regex_file:
        clear_textbox(o_e)
        rd = open(regex_file)
        exp = rd.read()
        o_e.insert(END,exp)
        rd.close()

def load_sample():
    sample_file = tkFileDialog.askopenfilename(filetypes=[("all files", "*")])
    if sample_file:
        clear_textbox(o_s)
        sd = open(sample_file)
        sample = sd.read()
        sample = sample.rstrip()
        o_s.insert(END,sample)

def quit():
    import sys
    sys.exit()

def save_regular_expression():
        print ('save_regular_expression')
        sys.stdout.flush()

def read_textbox(o):
    # Note how one can read all of the characters from a text box. The
    # 1.0 refers to the first character (line position 0) in the first
    # line (line 1).
    return o.get(1.0, END)
def regexp_colorize():
    global nblevels
    import types
    stack = []
    indicies = []
    # The format of indicies is a list of tuple each looking like
    # (type, min, max). Type can be report, no report, or lookahead.
    exp = read_textbox(o_e).rstrip()
    indicies.append(('report', 0, len(exp)))
    nblevels = 1
    for i in range(len(exp)):
        c = exp[i]
        if c == '\\':
            i += 1
            continue
        elif c == '(':
            c = exp[i+1]
            if c == '?':
                what = exp[1+2]
                if what == ':':
                    type = 'lookahead'
                else:
                    type = 'noreport'
            else:
                type = 'report'
            nblevels += 1
            min = i
            max = 0
            indicies.append((type, min, max))
            stack.append(len(indicies)-1)
        elif c == ')':
            idx = stack.pop()
            type, min, max = indicies[idx]
            indicies[idx] = (type, min, i)
    # Remove old colors.
    for level in range(nblevels):
        o_e.tag_remove(levels[level], 1.0, END)
    o_e.tag_remove("lookahead", 1.0, END)
    o_e.tag_remove("noreport", 1.0, END)
    # Colorize the regular expression
    i = 0
    for type,min,max in indicies:
        min_c = '1.0+%dchars' % min
        max_1 = max + 1
        max_c = '1.0+%dchars' % max_1
        o_e.tag_add(levels[i], min_c, max_c)
        i += 1
    # Colorize special items.
    for type,min,max in indicies:
        if type == 'report':
            continue
        min_c = '1.0+%dchars' % min
        max_1 = max + 1
        max_c = '1.0+%dchars' % (max + 1,)
        o_e.tag_add(type, min_c, max_c)

def sample_colorize():
    # Remove colors
    for level in range(nblevels):
        o_s.tag_remove(levels[level], 1.0, END)
    for i in range(len(mo)):
        if mo[i] == None:
            continue
        # Add the new colors
        if level <= len(mo[i].groups()):
            for level in range(nblevels):
                start, end = mo[i].span(level)
                min_c = '%d.0+%dchars' % (i+1, start)
                max_c = '%d.0+%dchars' % (i+1, end)
                o_s.tag_add(levels[level], min_c, max_c)


def save_regular_expression():
    regex_file = tkFileDialog.asksaveasfilename(filetypes=[("all files", "*")])
    if regex_file:
        rd = open(regex_file, 'w')
        rxp = read_textbox(o_e)
        rd.write(rxp)
        rd.close()


def save_sample():
    sample_file = tkFileDialog.asksaveasfilename(filetypes=[("all files", "*")])
    if sample_file:
        sd = open(sample_file, 'w')
        sample = read_textbox(o_s)
        sd.read(sample)
        sd.close()


class Vrex_for_Python:
    def __init__(self, master=None):
        _bgcolor = 'wheat'  # X11 color: #f5deb3
        _fgcolor = '#000000'  # Closest X11 color: 'black'
        _compcolor = '#b2c9f4' # Closest X11 color: 'SlateGray2'
        _ana1color = '#eaf4b2' # Closest X11 color: '{pale goldenrod}'
        _ana2color = '#f4bcb2' # Closest X11 color: 'RosyBrown2'
        font10 = "-family {DejaVu Sans} -size 14 -weight normal -slant roman -underline 0 -overstrike 0"
        font12 = "-family {DejaVu Sans} -size 16 -weight normal -slant roman -underline 0 -overstrike 0"
        self.style = ttk.Style()
        if sys.platform == "win32":
            self.style.theme_use('winnative')
        self.style.configure('.',background=_bgcolor)
        self.style.configure('.',foreground=_fgcolor)
        self.style.configure('.',font=font10)
        self.style.map('.',background=
            [('selected', _compcolor), ('active',_ana2color)])
        master.configure(background=_bgcolor)
        master.configure(highlightbackground="#f5deb3")
        master.configure(highlightcolor="black")


        self.menubar = Menu(master,font=font12,bg=_bgcolor,fg=_fgcolor)
        master.configure(menu = self.menubar)

        self.file = Menu(master,tearoff=0)
        self.menubar.add_cascade(menu=self.file,
                activebackground="#f4bcb2",
                activeforeground="#111111",
                background="wheat",
                font=font12,
                foreground="#000000",
                label="File")
        self.file.add_command(
                activebackground="#f4bcb2",
                background="wheat",
                command=load_regular_expression,
                font=font12,
                foreground="#000000",
                label="Load regular expression")
        self.file.add_command(
                activebackground="#f4bcb2",
                background="wheat",
                command=save_regular_expression,
                font=font12,
                foreground="#000000",
                label="Save regular expression")
        self.file.add_separator(
                background="wheat")
        self.file.add_command(
                activebackground="#f4bcb2",
                background="wheat",
                command=load_sample,
                font=font12,
                foreground="#000000",
                label="Load sample")
        self.file.add_command(
                activebackground="#f4bcb2",
                background="wheat",
                command=save_sample,
                font=font12,
                foreground="#000000",
                label="Save sample")
        self.file.add_separator(
                background="wheat")
        self.file.add_command(
                activebackground="#f4bcb2",
                background="wheat",
                command=quit,
                font=font12,
                foreground="#000000",
                label="Quit")
        self.menubar.add_command(
                activebackground="#f4bcb2",
                activeforeground="#000000",
                background="wheat",
                command=help,
                font=font12,
                foreground="#000000",
                label="Help")


        self.TPanedwindow1 = ttk.Panedwindow (master, orient="vertical")
        self.TPanedwindow1.place(relx=0.02,rely=0.0,relheight=0.91
                ,relwidth=0.97)
        self.TPanedwindow1_f1 = ttk.Labelframe(height=104, text='Regular Expression')
        self.TPanedwindow1.add(self.TPanedwindow1_f1)
        self.TPanedwindow1_f2 = ttk.Labelframe(height=208, text='Sample')
        self.TPanedwindow1.add(self.TPanedwindow1_f2)
        self.TPanedwindow1_f3 = ttk.Labelframe(text='Matches')
        self.TPanedwindow1.add(self.TPanedwindow1_f3)
        self.__funcid0 = self.TPanedwindow1.bind('<Map>', self.__adjust_sash0)

        self.Expression = ScrolledText (self.TPanedwindow1_f1)
        self.Expression.place(relx=0.02,rely=0.19,relheight=0.73,relwidth=0.96)
        self.Expression.configure(background="white")
        self.Expression.configure(font=font10)
        self.Expression.configure(highlightbackground="#f5deb3")
        self.Expression.configure(insertborderwidth="3")
        self.Expression.configure(selectbackground="#ddc8a1")
        self.Expression.configure(width=10)

        self.Sample = ScrolledText (self.TPanedwindow1_f2)
        self.Sample.place(relx=0.02,rely=0.1,relheight=0.85,relwidth=0.96)
        self.Sample.configure(background="white")
        self.Sample.configure(font=font10)
        self.Sample.configure(highlightbackground="#f5deb3")
        self.Sample.configure(insertborderwidth="3")
        self.Sample.configure(selectbackground="#ddc8a1")
        self.Sample.configure(width=10)
        self.Sample.bind('<Button-1>',self.sync_matches)

        self.Matches = ScrolledText (self.TPanedwindow1_f3)
        self.Matches.place(relx=0.02,rely=0.1,relheight=0.84,relwidth=0.96)
        self.Matches.configure(background="white")
        self.Matches.configure(font=font10)
        self.Matches.configure(highlightbackground="#f5deb3")
        self.Matches.configure(insertborderwidth="3")
        self.Matches.configure(selectbackground="#ddc8a1")
        self.Matches.configure(width=10)
        self.Matches.bind('<Button-1>',self.sync_sample)

        self.Go = Button (master)
        self.Go.place(relx=0.02,rely=0.94,height=30,width=47)
        self.Go.configure(activebackground="#f4bcb2")
        self.Go.configure(background=_bgcolor)
        self.Go.configure(disabledforeground="#b8a786")
        self.Go.configure(font=font10)
        self.Go.configure(highlightbackground="#f5deb3")
        self.Go.configure(text='''Go''')

        self.Match = Button (master)
        self.Match.place(relx=0.12,rely=0.94,height=30,width=73)
        self.Match.configure(activebackground="#f4bcb2")
        self.Match.configure(background=_bgcolor)
        self.Match.configure(command=lambda:display(0))
        self.Match.configure(disabledforeground="#b8a786")
        self.Match.configure(font=font10)
        self.Match.configure(highlightbackground="#f5deb3")
        self.Match.configure(text='''Match''')

        self.TSizegrip1 = ttk.Sizegrip(master)
        self.TSizegrip1.place(anchor=SE,relx=1.0,rely=1.0)

        self.Button1 = Button (master)
        self.Button1.place(relx=0.25,rely=0.94,height=30,width=34)
        self.Button1.configure(activebackground="#f4bcb2")
        self.Button1.configure(background="blue")
        self.Button1.configure(command=lambda:display(1))
        self.Button1.configure(disabledforeground="#b8a786")
        self.Button1.configure(font=font10)
        self.Button1.configure(foreground="white")
        self.Button1.configure(highlightbackground="#f5deb3")
        self.Button1.configure(text='''1''')

        self.Button2 = Button (master)
        self.Button2.place(relx=0.32,rely=0.94,height=30,width=34)
        self.Button2.configure(activebackground="#f4bcb2")
        self.Button2.configure(background="darkgreen")
        self.Button2.configure(command=lambda:display(2))
        self.Button2.configure(disabledforeground="#b8a786")
        self.Button2.configure(font=font10)
        self.Button2.configure(foreground="white")
        self.Button2.configure(highlightbackground="#f5deb3")
        self.Button2.configure(text='''2''')

        self.Button3 = Button (master)
        self.Button3.place(relx=0.38,rely=0.94,height=30,width=34)
        self.Button3.configure(activebackground="#f4bcb2")
        self.Button3.configure(background="magenta")
        self.Button3.configure(command=lambda:display(3))
        self.Button3.configure(disabledforeground="#b8a786")
        self.Button3.configure(font=font10)
        self.Button3.configure(foreground="blue")
        self.Button3.configure(highlightbackground="#f5deb3")
        self.Button3.configure(text='''3''')

        self.Button4 = Button (master)
        self.Button4.place(relx=0.45,rely=0.94,height=30,width=34)
        self.Button4.configure(activebackground="#f4bcb2")
        self.Button4.configure(background="sienna")
        self.Button4.configure(command=lambda:display(4))
        self.Button4.configure(disabledforeground="#b8a786")
        self.Button4.configure(font=font10)
        self.Button4.configure(foreground="white")
        self.Button4.configure(highlightbackground="#f5deb3")
        self.Button4.configure(text='''4''')

        self.Button5 = Button (master)
        self.Button5.place(relx=0.52,rely=0.94,height=30,width=34)
        self.Button5.configure(activebackground="#f4bcb2")
        self.Button5.configure(background="purple")
        self.Button5.configure(command=lambda:display(5))
        self.Button5.configure(disabledforeground="#b8a786")
        self.Button5.configure(font=font10)
        self.Button5.configure(foreground="white")
        self.Button5.configure(highlightbackground="#f5deb3")
        self.Button5.configure(text='''5''')

        self.Button6 = Button (master)
        self.Button6.place(relx=0.58,rely=0.94,height=30,width=34)
        self.Button6.configure(activebackground="#f4bcb2")
        self.Button6.configure(background="firebrick")
        self.Button6.configure(command=lambda:display(6))
        self.Button6.configure(disabledforeground="#b8a786")
        self.Button6.configure(font=font10)
        self.Button6.configure(foreground="white")
        self.Button6.configure(highlightbackground="#f5deb3")
        self.Button6.configure(text='''6''')

        self.Button7 = Button (master)
        self.Button7.place(relx=0.65,rely=0.94,height=30,width=34)
        self.Button7.configure(activebackground="#f4bcb2")
        self.Button7.configure(background="deeppink")
        self.Button7.configure(command=lambda:display(7))
        self.Button7.configure(disabledforeground="#b8a786")
        self.Button7.configure(font=font10)
        self.Button7.configure(foreground="blue")
        self.Button7.configure(highlightbackground="#f5deb3")
        self.Button7.configure(text='''7''')

        self.Button8 = Button (master)
        self.Button8.place(relx=0.72,rely=0.94,height=30,width=34)
        self.Button8.configure(activebackground="#f4bcb2")
        self.Button8.configure(background="green4")
        self.Button8.configure(command=lambda:display(8))
        self.Button8.configure(disabledforeground="#b8a786")
        self.Button8.configure(font=font10)
        self.Button8.configure(foreground="white")
        self.Button8.configure(highlightbackground="#f5deb3")
        self.Button8.configure(text='''8''')

        self.Button9 = Button (master)
        self.Button9.place(relx=0.78,rely=0.94,height=30,width=34)
        self.Button9.configure(activebackground="#ffffcd")
        self.Button9.configure(background="deepskyblue1")
        self.Button9.configure(command=lambda:display(9))
        self.Button9.configure(disabledforeground="#b8a786")
        self.Button9.configure(font=font10)
        self.Button9.configure(foreground="blue")
        self.Button9.configure(highlightbackground="#f5deb3")
        self.Button9.configure(text='''9''')

        self.Quit = Button (master)
        self.Quit.place(relx=0.87,rely=0.94,height=30,width=58)
        self.Quit.configure(activebackground="#f4bcb2")
        self.Quit.configure(background=_bgcolor)
        self.Quit.configure(command=quit)
        self.Quit.configure(disabledforeground="#b8a786")
        self.Quit.configure(font=font10)
        self.Quit.configure(highlightbackground="#f5deb3")
        self.Quit.configure(text='''Quit''')


    def __adjust_sash0(self, event):
        paned = event.widget
        pos = [104,317,]
        i = 0
        for sash in pos:
            paned.sashpos(i, sash)
            i += 1
        paned.unbind('<map>', self.__funcid0)
        del self.__funcid0

    def sync_matches(self,p1):
        ''' Function which makes sure that line in Matches
        corresponding to the like selected with button-1 in Sample is
        visible.'''
        index = self.Sample.index(CURRENT)
        self.Matches.see(index)

    def sync_sample(self,p1):
        ''' Function which makes sure that line in Sample
        corresponding to the like selected with button-1 in Matches is
        visible.'''
        index = self.Matches.index(CURRENT)
        line, char = index.split('.')
        self.Sample.see(index)





# The following code is added to facilitate the Scrolled widgets you specified.
class AutoScroll(object):
    '''Configure the scrollbars for a widget.'''

    def __init__(self, master):
        vsb = ttk.Scrollbar(master, orient='vertical', command=self.yview)
        hsb = ttk.Scrollbar(master, orient='horizontal', command=self.xview)

        self.configure(yscrollcommand=self._autoscroll(vsb),
            xscrollcommand=self._autoscroll(hsb))
        self.grid(column=0, row=0, sticky='nsew')
        vsb.grid(column=1, row=0, sticky='ns')
        hsb.grid(column=0, row=1, sticky='ew')

        master.grid_columnconfigure(0, weight=1)
        master.grid_rowconfigure(0, weight=1)

        # Copy geometry methods of master  (took from ScrolledText.py)
        if py31:
            methods = Pack.__dict__.keys() | Grid.__dict__.keys() \
                  | Place.__dict__.keys()
        else:
            methods = Pack.__dict__.keys() + Grid.__dict__.keys() \
                  + Place.__dict__.keys()

        for meth in methods:
            if meth[0] != '_' and meth not in ('config', 'configure'):
                setattr(self, meth, getattr(master, meth))

    @staticmethod
    def _autoscroll(sbar):
        '''Hide and show scrollbar as needed.'''
        def wrapped(first, last):
            first, last = float(first), float(last)
            if first <= 0 and last >= 1:
                sbar.grid_remove()
            else:
                sbar.grid()
            sbar.set(first, last)
        return wrapped

    def __str__(self):
        return str(self.master)

def _create_container(func):
    '''Creates a ttk Frame with a given master, and use this new frame to
    place the scrollbars and the widget.'''
    def wrapped(cls, master, **kw):
        container = ttk.Frame(master)
        return func(cls, container, **kw)
    return wrapped

class ScrolledText(AutoScroll, Text):
    '''A standard Tkinter Text widget with scrollbars that will
    automatically show/hide as needed.'''
    @_create_container
    def __init__(self, master, **kw):
        Text.__init__(self, master, **kw)
        AutoScroll.__init__(self, master)

if __name__ == '__main__':
    vp_start_gui()



