#! /usr/bin/env python
# -*- python -*-
# Generated by PAGE version 4.0
# In conjunction with Tcl version 8.6
#    Feb. 13, 2013 08:00:04 PM
import sys

py2 = py30 = py31 = False
version = sys.hexversion
if version >= 0x020600F0 and version < 0x03000000 :
    py2 = True    # Python 2.6 or 2.7
    from Tkinter import *
    import ttk
elif version >= 0x03000000 and version < 0x03010000 :
    py30 = True
    from tkinter import *
    import ttk
elif version >= 0x03010000:
    py31 = True
    from tkinter import *
    import tkinter.ttk as ttk
else:
    print ("""
    You do not have a version of python supporting ttk widgets..
    You need a version >= 2.6 to execute PAGE modules.
    """)
    sys.exit()



def vp_start_gui():
    '''Starting point when module is the main routine.'''
    global val, w, root
    root = Tk()
    root.title('Vrex_Help')
    root.geometry('600x626+785+197')
    w = Vrex_Help (root)
    init()
    root.mainloop()

w = None
def create_Vrex_Help (root):
    '''Starting point when module is imported by another program.'''
    global w, w_win
    if w: # So we have only one instance of window.
        return
    w = Toplevel (root)
    w.title('Vrex_Help')
    w.geometry('600x626+785+197')
    w_win = Vrex_Help (w)
    init()
    return w_win

def destroy_Vrex_Help ():
    global w
    w.destroy()
    w = None

def init():
    pass


def load_vrex_help(o):
    '''Note that the following paragraphs of the help message are each
    a single line of text. The scrolled text box is configured with
    'wrap="word"' to keep thing correct when the help window is resized.'''
    help = '''
Vrex is a program for testing Python regular expressions.  The GUI is made up of a menu a paned window with three adjustable sub-windows each of which contains a scrolled test window and a row of buttons which control the action of the program. The GUI may be resized as may this window.

One enters the regular expression under test into the top text box, and the sample which is the subject of the regular expression match into the middle text box.  One may use the File menu to load files into the text boxes, one may directly type entries or use the normal cut and paste facilities of the operating system.

Pressing the Go button causes the match to be attempted.  Also, colorization is applied to both the regular expression and to the sample. The regular expression is colorized to show the portions of the regular expression can be extracted individually. This has been called grouping. And if the match is successful the corresponding to a group within the sample are displayed in the same colors as in the regular expression window.

By selecting one of the row of buttons marked match, 1, 2, ..., 9, the portions of the sample corresponding to extracted groups are displayed in the match window. The buttons are colored to match the color of the corresponding group.

You can use the File menu to load to save both the regular expression and the sample as well as invoke this help window.

The Quit Button terminates the program. The File menu also has a Quit entry that terminates the program.

In normal usage, one loads a sample and a regular expression and experiments with incrementally changes to both and testing by hitting the go button. When you are satisfied you can save the regular expression or put it on the clipboard by selecting the characters that make up the regular expression.

You can also enter a whole file of sample strings using File->Load Sample. In that case, when you select Go, the regular expression candidate will be applied to each line individually in the sample and the sample will be colorized accordingly.  In the Matches window you will see the individual match results for each line. The two windows can be synchronized by clicking in either the Sample window or the Matches window and the corresponding line will be visible in the other window. You can add build a set of samples by adding them to the sample window and saving the sample to a file.
'''

    o.insert(END, help)

def close():
    destroy_Vrex_Help ()


class Vrex_Help:
    def __init__(self, master=None):
        _bgcolor = 'wheat'  # X11 color: #f5deb3
        _fgcolor = '#000000'  # X11 color: 'black'
        _compcolor = '#b2c9f4' # Closest X11 color: 'SlateGray2'
        _ana1color = '#eaf4b2' # Closest X11 color: '{pale goldenrod}'
        _ana2color = '#f4bcb2' # Closest X11 color: 'RosyBrown2'
        font10 = "-family {DejaVu Sans} -size 14 -weight normal -slant roman -underline 0 -overstrike 0"
        self.style = ttk.Style()
        self.style.configure('.',background=_bgcolor)
        self.style.configure('.',foreground=_fgcolor)
        self.style.configure('.',font=font10)
        self.style.map('.',background=
            [('selected', _compcolor), ('active',_ana2color)])
        master.configure(background=_bgcolor)
        master.configure(highlightbackground="#f5deb3")
        master.configure(highlightcolor="black")


        self.TButton1 = ttk.Button (master)
        self.TButton1.place(relx=0.37,rely=0.94,height=31,width=101)
        self.TButton1.configure(command=close)
        self.TButton1.configure(takefocus="")
        self.TButton1.configure(text='''Close''')

        self.Scrolledtext1 = ScrolledText (master)
        self.Scrolledtext1.place(relx=0.02,rely=0.02,relheight=0.9
                ,relwidth=0.96)
        self.Scrolledtext1.configure(background="white")
        self.Scrolledtext1.configure(font=font10)
        self.Scrolledtext1.configure(highlightbackground="#f5deb3")
        self.Scrolledtext1.configure(insertborderwidth="3")
        self.Scrolledtext1.configure(selectbackground="#ddc8a1")
        self.Scrolledtext1.configure(width=10)
        self.Scrolledtext1.configure(wrap="word")

        self.TSizegrip1 = ttk.Sizegrip(master)
        self.TSizegrip1.place(anchor=SE,relx=1.0,rely=1.0)

        load_vrex_help(self.Scrolledtext1)




# The following code is added to facilitate the Scrolled widgets you specified.
class AutoScroll(object):
    '''Configure the scrollbars for a widget.'''

    def __init__(self, master):
        vsb = ttk.Scrollbar(master, orient='vertical', command=self.yview)
        hsb = ttk.Scrollbar(master, orient='horizontal', command=self.xview)

        self.configure(yscrollcommand=self._autoscroll(vsb),
            xscrollcommand=self._autoscroll(hsb))
        self.grid(column=0, row=0, sticky='nsew')
        vsb.grid(column=1, row=0, sticky='ns')
        hsb.grid(column=0, row=1, sticky='ew')

        master.grid_columnconfigure(0, weight=1)
        master.grid_rowconfigure(0, weight=1)

        # Copy geometry methods of master  (took from ScrolledText.py)
        if py31:
            methods = Pack.__dict__.keys() | Grid.__dict__.keys() \
                  | Place.__dict__.keys()
        else:
            methods = Pack.__dict__.keys() + Grid.__dict__.keys() \
                  + Place.__dict__.keys()

        for meth in methods:
            if meth[0] != '_' and meth not in ('config', 'configure'):
                setattr(self, meth, getattr(master, meth))

    @staticmethod
    def _autoscroll(sbar):
        '''Hide and show scrollbar as needed.'''
        def wrapped(first, last):
            first, last = float(first), float(last)
            if first <= 0 and last >= 1:
                sbar.grid_remove()
            else:
                sbar.grid()
            sbar.set(first, last)
        return wrapped

    def __str__(self):
        return str(self.master)

def _create_container(func):
    '''Creates a ttk Frame with a given master, and use this new frame to
    place the scrollbars and the widget.'''
    def wrapped(cls, master, **kw):
        container = ttk.Frame(master)
        return func(cls, container, **kw)
    return wrapped

class ScrolledText(AutoScroll, Text):
    '''A standard Tkinter Text widget with scrollbars that will
    automatically show/hide as needed.'''
    @_create_container
    def __init__(self, master, **kw):
        Text.__init__(self, master, **kw)
        AutoScroll.__init__(self, master)

if __name__ == '__main__':
    vp_start_gui()



